#define MOTOR_NR 11 // set number of pumps
const int MOTORS[MOTOR_NR] = {2,3,4,5,6,7,8,9,10,11,12}; // define Arduino Pins

unsigned long motorWaitTime[MOTOR_NR] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
unsigned long motorRunTime[MOTOR_NR] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

boolean isWaiting[MOTOR_NR] = {true, true, true, true, true, true, true, true, true, true, true};
boolean isRunning[MOTOR_NR] = {false, false, false, false, false, false, false, false, false, false, false};

int waitIntervals[MOTOR_NR] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

int defaultInterval = 1000;
int runIntervals[MOTOR_NR] = {defaultInterval, defaultInterval, defaultInterval, defaultInterval, defaultInterval, defaultInterval, defaultInterval*0.7, defaultInterval, defaultInterval, defaultInterval, defaultInterval};

boolean running = true;
boolean looping = true;

void setup() 
{
    Serial.begin(9600);

    for(int i=0; i<MOTOR_NR; i++){
        pinMode(MOTORS[i], OUTPUT);
    }

    // for(int i=0; i<MOTOR_NR; i++){
    //     waitIntervals[i] = 100;
    // }
}

void loop() {

    // run pumps
    for(int i=0; i<MOTOR_NR; i++){
        runMotor(i, waitIntervals[i], runIntervals[i]);
    }
}


void runMotor(int _whichMotor, int _delayInterval, int _interval) {

    if (isWaiting[_whichMotor] == true) {
        // output state to serial monitor
        Serial.print("Motor waiting: ");
        Serial.println(_whichMotor);

        motorWaitTime[_whichMotor]= millis(); // save the time
        isWaiting[_whichMotor] = false; // set current state
    }

    if((millis() - motorWaitTime[_whichMotor]) > _delayInterval && isWaiting[_whichMotor] == false && isRunning[_whichMotor] == false) {
        // output state to serial monitor
        Serial.print("Motor running: ");
        Serial.println(_whichMotor);

        motorRunTime[_whichMotor]= millis(); // save the time
        digitalWrite(MOTORS[_whichMotor], HIGH);
        isRunning[_whichMotor] = true; // set current state
    }


    if((millis() - motorRunTime[_whichMotor]) > _interval && isRunning[_whichMotor] == true) {
        // output state to serial monitor
        Serial.print("Motor stopped: ");
        Serial.println(_whichMotor);

        digitalWrite(MOTORS[_whichMotor], LOW);
        isRunning[_whichMotor] = false; // set current state
        isWaiting[_whichMotor] = true; // set current state
    }
}